# API Documentation

With iVvy's robust API, you can connect all your core business apps to meet your unique needs.

Please note: use of the iVvy API is subject to additional fees. For pricing details, please contact <sales@ivvy.com>.

This documentation covers all of the iVvy products, including:

* **iVvy Venue Software** - Software used by venues to market, manage and report on their venues.
* **iVvy Events Software** - Software used by Event Organisers to manage the procurement, marketing, online registration, onsite event apps and surveys.
* **iVvy Marketplace** - The online marketplace of events suppliers.
* **iVvy Contacts CRM** - The contact database and CRM features accessible by the Events and Venues Software
* **Partner Software** - The application that allows partners to create Booking Engines and distribute supplier inventory to their customers.

Browse through the topics below to find exactly what you're looking for or check our [Getting Started Guide](https://developer.ivvy.com/getting-started) to get the ball rolling.

{% content-ref url="/pages/-LH2Zq2wY3aS6NCmGyhw" %}
[Getting Started](/getting-started)
{% endcontent-ref %}

{% content-ref url="/pages/-LI8d8wV4hH2bOgIvCGh" %}
[Contacts & Companies](/contact)
{% endcontent-ref %}

{% content-ref url="/pages/-LH2ZtCZo5xyElQZ839I" %}
[Event](/events)
{% endcontent-ref %}

{% content-ref url="/pages/-LI8d8wsI\_h2Nyxz5lH3" %}
[Venue](/venues)
{% endcontent-ref %}

{% content-ref url="/pages/-LI8d8x823apoSYRdrRw" %}
[Invoice](/invoice)
{% endcontent-ref %}

{% content-ref url="/pages/-LI8d8xCiapzIZQ40FCQ" %}
[Account](/account)
{% endcontent-ref %}

{% content-ref url="/pages/-LfrVXNRw295J7o77jvl" %}
[Partner](/partner)
{% endcontent-ref %}


# Getting Started

The iVvy API allows apps to integrate directly with the iVvy product suite. Some typical use cases include:

* Connecting a Customer Relationship Manager with iVvy
* Connecting a Point of Sale System to iVvy Venues
* Pushing Availability, Rates & Inventory into iVvy Venues through a Central Reservation System or Property Management System
* Connecting an Accounting Package with iVvy Events or Venues

The API described in this document follows an RPC (Remote Procedure Call) paradigm. Each RPC method is grouped into a few higher level namespaces to help organise this document in a more logical manner.

iVvy takes security very seriously and the API described in this document has been designed to be as secure as possible.

* All transport has been secured by utilising industry standard TLS
* Key generation can be done first authenticating with the iVvy backend system
* All requests must be signed using the key/secret pair to prove the request was made by a valid key
* All requests have a time limit to avoid future replay attacks

To help you get started we offer sdk libraries in [C#](https://github.com/ivvycode/ivvy-sdk-net), and [Javascript](https://github.com/ivvycode/ivvy-sdk-js).

**Next Steps:**

* Download an [example extension](https://github.com/ivvycode/example-extension) designed to work on the AWS infrastructure
* Try making an [API call](https://developer.ivvy.com/getting-started/test)


# Obtaining Keys

For those who wish to develop a way to extract data from iVvy via programming means, whether to display on your website or for entering into a different system, you will need to generate an API Key.

Please note: use of the iVvy API is subject to additional fees. For pricing details, please contact <sales@ivvy.com>.


# Creating the request

Requests to the API are over the standard HTTP (HyperText Transfer Protocol). The protocol defines three parts to every request.

1. the method/uri header
2. a number of request headers
3. optional body of the request

`Note also that the HTTP request also needs to be secured by a TLS/SSL connection, often referred to as HTTPS (or HTTP over SSL). iVvy uses industry standard TLS (Transport Layer Security, the successor to SSL, Secure Sockets Layer) to secure the HTTP transport to the API to ensure eavesdropping on the connection by third parties is protected.`


# Method/URI Header

This is a line consisting of the method of the request, followed by the request URI, followed by the HTTP version. i.e.

`POST /api/1.0/event?action=getEventList HTTP/1.0`

This example is for a request, to iVvy’s api ‘event’ namespace, calling the ‘getEventList’ API call, using HTTP version 1.0. Note the HTTP method for calls to the iVvy API are all POST requests. The api version being called is 1.0. Currently supported versions are:

* 1.0

The URI in the request must always start with /api/{version} (where {version} is the specific api version, e.g. 1.0) followed by the namespace of the eventual api call to make. All requests must also provide the action parameter indicating the API call to invoke.


# Request Headers

Request headers are defined by the header name, followed by a colon (:) followed by a space, followed by the value of the header. A number of headers are used with the iVvy API.


# Standard Headers

## HOST (Required)

You will need to verify which region that you wish to integrate with to determine your host. If you are unsure, you can contact the support team for assistance.

For integrations on our AU Servers, the host is:

* [api.ap-southeast-2.ivvy.com](http://api.ap-southeast-2.ivvy.com/)

For integrations on our US Servers, the host is:

* [api.us-west-2.ivvy.com](http://api.us-west-2.ivvy.com/)

For integrations on our UK Servers, the host is:

* [api.eu-west-2.ivvy.com](http://api.eu-west-2.ivvy.com/)

Contact <support@ivvy.com> if you are unsure which value to use.

## Date (Required unless using [IVVY-Date header](/getting-started/creating-the-request/request-headers/custom-headers#ivvy-date-optional))

The date header determines the date the request was made. The iVvy API uses this date, compared to the date of the server to determine if the request is within the time to live setting. (Currently requests over 5 minutes old are deemed invalid, this value may change in the future.)

`Date: Thu, 12 Apr 2012 07:17:06 UTC`

## Content-MD5 (Required)

This is the md5 sum of the body of the request. This header is used to verify the contents of the body of the request have not been altered during transport. Note that if there is no content in the body, the MD5 for the request must still be calculated. See [Calculating MD5](/development-reference/calculating-md5) for more details on how to calculate the value for this field.

## Content-Type

The content type of the request body. Valid request types for the api are...

* application/json

## Content-Length

The length of the request body, in bytes.


# Custom Headers

A number of custom headers can be used with the request to the API.

## IVVY-Date (Optional)

If your HTTP client does not allow the date header to be accessed or set, you can optionally use this header to use for the date string. Note if this header is used, the ‘date’ part of the [signed string](/getting-started/creating-the-request/signing-the-request) will need to be empty. The format of the value of this header will be the[ iVvy Timestamp Format](/development-reference/timestamp-format), NOT the string format of the standard Date header.

## X-Api-Authorization (Required)

This is the same format at the standard HTTP Authorization header. For iVvy requests, the format is...

`X-Api-Authorization: IWS key:signature`

… where IWS is the authentication system used by iVvy, key is the key used to sign the request, and the signature is the HMAC-SHA1 signature of the request. See [Signing the request](/getting-started/creating-the-request/signing-the-request) for details on how to sign a request.

The iVvy API server will lookup the secret key associated with the key used in this header, then use the details in the request in association with the secret key, then reconstruct the [HMAC-SHA1](/development-reference/hmac-sha1) hash. Only when the calculated hash, and the signature sent through this header match will the request be authenticated.


# Signing the request

Every request to the API must be signed with the accounts or users API key. Signing the request is obtained by the following pseudo-code:

```javascript
method := POST
contentMd5 := md5(<body of the request>)
contentType := the value of the Content-Type header
contentSign := {contentMd5}{contentType}
date := the date header of the request (i.e. Tue, 03 Apr, 2012 22:23:24 utc)
        NOTE: if using the IVVY-Date header, this field will be empty
requestString := the entire request string used in the request
apiVersion := the api version to use
ivvyHeaders := Concatenated string of all headers starting with IVVY, removing all the
               Dashes (-) and underscore (_) characters in the header, in alphabetical order, joined together with the
               ampersand (&) character
initialStringToSign := {method}{contentSign}{date}{requestString}{apiVersion}{ivvyHeaders}
stringToSign := lowercase version of the initialStringToSign
```

For example, the following request...

```javascript
POST /api/1.0/test?action=ping HTTP/1.0
Host: api.ap-southeast-2.ivvy.com
Date: Tue, 03 Apr 2012 22:23:24 UTC
Content-MD5: a09f600c77a6dbd947db24c61e8935ca
Content-Type: application/json
Content-Length: 18
X-Api-Version: 1.0
X-Api-Authorization: IWS {key:signature here}
IVVY-Date: 2012-04-03 22:23:24
```

```javascript
{
  "example":"body"
}
```

… will require the following string to be signed …

`posta09f600c77a6dbd947db24c61e8935caapplication/json/api/1.0/test?action=ping1.0ivvydate=2012-04-03 22:23:24`

Note the entire string is set to lowercase before signing.

Signing is achieved using the HMAC algorithm, using SHA1 encryption. See [HMAC-SHA1](/development-reference/hmac-sha1) for further details


# Query Parameters

The api exposes a RPC interface. As such there is a required query parameter, the ‘action’ parameter. This will identify the RPC call to invoke.


# Test Ping

## Namespace

Used for testing the access to the api. This call takes no parameters and responds to the request with an ack message, with the [timestamp](https://developer.ivvy.com/development-reference/timestamp-format) from the server.

### API URL

```
[PlatformAddress]/api/1.0/test?action=ping
```


# Interpreting the response

The response will be given back will be the response in [JSON](/development-reference/json-encoding) format.


# Collections

Some results return collections of objects. E.g. event?action=getEventList. The resulting [JSON](/development-reference/json-encoding) response for these collections will be an object with the following properties.

1. meta: An object providing information about the result set. The following keys may exist
   * totalResults: The number of results in the complete collection
   * start: The starting index of the collection this result represents
   * perPage: The number of items per page of results
   * count: The number of objects included in this result.
2. results: An array of objects


# Pagination

Some requests (mostly the requests that return [collections](/getting-started/interpreting-the-response/collections)) may also accept some pagination options.

* perPage: The number of items to return per page. Note that most requests have a cap on this number and providing a perPage option greater than that cap will not have any effect.
* start: The record to start paging from. Note this number is zero based, i.e. to return results from the very first result, the start will need to equal 0 (which is the default). Note also this is not the page to start at. For example to get the second page from a list of results that have 20 results per page, the start property will need to equal 20 (i.e. starting at the 21st result)


# Filtering

Some requests (mostly requests that return [collections ](/getting-started/interpreting-the-response/collections)and/or take [pagination ](/getting-started/interpreting-the-response/pagination)requests) may also accept a filter argument. The structure of this filter will be an object with the key’s being what needs to be filtered, and the value will be the content of the filter.

There are a number of options that may modify the filter behaviour. These are appended to the end of the key to filter. The accepted modifiers are:

* **\_\_CONTAINS**: Return the results that contain the value.
* **\_\_NOTCONTAINS**: Return the results that do not contain the value.
* **\_\_BEGINS**: Return the results that start with the value.
* **\_\_ENDS**: Return the results that end with the value.
* **\_\_LESSTHAN**: Return the results that are less than or equal to the value.
* **\_\_GREATERTHAN**: Return the results that are greater than or equal to the value.
* **\_\_NOT**: Return the results that are not equal to the value.
* **\_\_EMPTY**: Returns results that are empty

If you want to search for ‘Null’ values, you can use the special value ‘**ISNULL**’ for the filter value.

**Example: Filter all the results where the firstName = Bob**

`{"filter":{"firstName":"Bob"}}`

**Example: Filter all results where the firstName starts with ‘M’**

`{"filter":{"firstName__BEGINS":"M"}}`

**Example: Filter all results where the birthDay has not been set**

`{"filter":{"firstName":"__ISNULL__"}}`


# Exceptions

If an error occurred the response will be a [JSON](/development-reference/json-encoding) representation of what went wrong. This will provide the error code, a brief message as well as a specific code. The specific code is a useful piece of information to be provided in any bug reports.

Current exception codes and meanings are:

| Code | Description           |
| ---- | --------------------- |
| 400  | Bad Request           |
| 401  | Unauthorized          |
| 403  | Forbidden             |
| 404  | Not Found             |
| 405  | Method Not Allowed    |
| 406  | Not Acceptable        |
| 429  | Too Many Requests     |
| 460  | Unknown               |
| 461  | Failed Request        |
| 462  | Session Expired       |
| 463  | Key Revoked           |
| 500  | Internal Server Error |
| 501  | Not Implemented       |

Some exceptions will have an additional piece of information associated with the exception, which will contain more specific message about the exception.

**Exception: Specific Code 23005**

The required Date or iVvyDate parameter does not fall within 5 minutes of UTC time, invalidating the request. Refer [here ](/getting-started/creating-the-request/request-headers/standard-headers#date-required-unless-using-ivvy-date-header)for more information on this.

**Example: Date outside of accepted time range**

```javascript
Request (venue?action=getVenueList)
{
	   "ivvydate":"2000-06-01 00:00:00"
}
{
     "errorCode": 401,
     "message": "Request is stale",
     "specificCode": 23005
}
```

**Exception: Specific Code 23016**

A parameter provided in the request did not validate correctly. For example, the API might have been expecting a number, but a string was provided instead. This exception gets thrown when the first invalid parameter is found.

The additional messages will contain the messages from the validator as to why the value was not validated.

**Example: Key does not validate error**

```javascript
Request (contact?action=getContact):
{
    "id":"wrong"
}
Response:
{
    "errorCode":400,
    "message":"'id' does not validate",
    "specificCode":23016,
    "additionalMessages":["Value must be a whole number"]
}
```

**Exception: Specific Code 23017**

A required parameter was missing from the request.

Example: Key is required error

```javascript
Request (contact?action=getContact):
{}
Response:
{
  "errorCode":400,
  "message":"'id' is required",
  "specificCode":23017
}
```


# Response Headers

## Content-Type

This header will identify the content type of the response. At this time only one content type is supported, the application/json type.


# Dates

Responses from the iVvy API may contain dates. In all cases (unless otherwise stated in documentation for the specific action) the dates are in Universal Coordinated Time (UTC). Care must be taken when using or displaying these dates to ensure they: a) maintain their UTC time zone for communication with the API, and; b) represented in the appropriate time zone for users utilizing the date.

Dates may be represented as a string which must be parsed appropriately if it is to be used. Where possible any dates will be converted to the[ iVvy Timestamp Format](/development-reference/timestamp-format), which is a simple to understand text format to represent a specific point in time to the second.


# Batch

As a way of providing asynchronous access to iVvy’s API, there is a namespace added for batch requests. This also provides a way to run multiple api calls in a batch and provide the result of all the api calls via a URL callback.

## Namespace

`batch`


# Run

## Run

<mark style="color:green;">`POST`</mark> `[PlatformAddress]/api/1.0/batch?action=run`

#### Path Parameters

| Name        | Type   | Description                                                                                          |
| ----------- | ------ | ---------------------------------------------------------------------------------------------------- |
| jobs        | string | Array of api jobs to be run on the api. Each job needs to have keys                                  |
| callbackUrl | string | The URL to hit with a POST request after the batch has been run, with a JSON object of the responses |

{% tabs %}
{% tab title="200 " %}

```
{
    "asyncId":"e35e06ee592d17a42dc9e6252a058617"
}
```

{% endtab %}
{% endtabs %}

## Example Request

```javascript
{
  "jobs": [
	{"namespace":"event","action":"inviteContacts","params":{"event":1,"contacts":[1,2,3]}},
	{"namespace":"event","action":"inviteContacts","params":{"event":2,"contacts":[1,2,4]}},
  ],
  "callbackUrl":"http://example.callback.url.com"
}
```

## Keys

| namespace |
| --------- |
| action    |
| params    |

## Returns

| Property | Description                      |
| -------- | -------------------------------- |
| asyncId  | Identifier for the batch request |

## Throws

| Code                 | Description                                                      |
| -------------------- | ---------------------------------------------------------------- |
| Specific Code: 24092 | Incorrect Job Format                                             |
| Specific Code: 24093 | Empty job parameter found                                        |
| Specific Code: 24091 | The information was not saved                                    |
| Specific Code: 24448 | The maximum number of jobs can be put on a single request is 200 |

The run action takes an array of api calls and returns an identifier that can be used to identify the batch. Keep this identifier as it can be used to identify the response of the batch request, as well as being used to fetch the progress and results of the request.

To run a batch job, an JSON object must be provided with the following keys:

* jobs: An array of jobs, each element being an object with the following keys
  * namespace: The namespace of the api call
  * action: The api call to make
  * params: Any parameters required for the api call
* callbackUrl: A URL that will be called after the batch has completed.
  * The request will be a POST request
  * The response will be a JSON object with the following keys
    * asyncId: The async identifier provided when the batch was created
    * results: An array of objects for each result of the batch, with the following keys
      * namespace: The namespace of the call for the response
      * action: The action of of the call for the response
      * request: The original request parameters used
      * response: The response of the api call


# Progress

## Progress

<mark style="color:green;">`POST`</mark> `[PlatformAddress]/api/1.0/batch?action=progress`

#### Path Parameters

| Name  | Type   | Description                                         |
| ----- | ------ | --------------------------------------------------- |
| async | string | The asyncId for the batch job to check progress for |

{% tabs %}
{% tab title="200 " %}

```
{
  "progress":33
}
```

{% endtab %}
{% endtabs %}

## Example Request

Fetch the progress of a batch job

```javascript
{
  "async":"a7ec88af7d710bf51b188004bb532d77"
}
```

## Returns

| Property | Description                                                       |
| -------- | ----------------------------------------------------------------- |
| progress | The progress of the batch job, as a percentage of work completed. |

## Throws

| Code                 | Description          |
| -------------------- | -------------------- |
| Specific Code: 24105 | Could not find batch |

The progress action takes the asyncId as a parameter and returns back the progress of the batch job as a percentage.


# Result

## Results

<mark style="color:green;">`POST`</mark> `[PlatformAddress]/api/1.0/batch?action=results`

The results action takes the asyncId as a parameter and fetch the results of a batch request after it has been executed.

#### Path Parameters

| Name  | Type   | Description |
| ----- | ------ | ----------- |
| async | string |             |

{% tabs %}
{% tab title="200 " %}

```
{
  "asyncId": "e35e06ee592d17a42dc9e6252a058617",
  "results": [
    {
      "namespace": "event",
      "action": "inviteContacts",
      "request": {
        "event": 1,
        "contacts": [1, 2, 3]
      },
      "response": {
        // Response data for the first job
      }
    },
    {
      "namespace": "event",
      "action": "inviteContacts",
      "request": {
        "event": 2,
        "contacts": [1, 2, 4]
      },
      "response": {
        // Response data for the second job
      }
    },
    // Additional results for other jobs in the batch
  ]
}

```

{% endtab %}
{% endtabs %}

## Example Request

```javascript
{
  "async":"a7ec88af7d710bf51b188004bb532d77"
}
```

## Returns

The response will be a JSON object with the following keys:

* asyncId: The async identifier provided when the batch was created.
* results: An array of objects for each result of the batch, with the following keys:
  * namespace: The namespace of the call for the response.
  * action: The action of the call for the response.
  * request: The original request parameters used.
  * response: The response of the API call.

## Throws

| Code                 | Description             |
| -------------------- | ----------------------- |
| Specific Code: 24114 | Batch job not completed |
| Specific Code: 24115 | Could not find batch    |

This structure facilitates retrieving the results of each individual job within the batch request, along with the corresponding request parameters and response data, or it indicates that the batch job is not yet completed. Please note that the data will not be available after 2 days.


# Restart

## Restart

<mark style="color:green;">`POST`</mark> `[PlatformAddress]/api/1.0/batch?action=restart`

The restart action takes the asyncId as a parameter and returns the success of the call. Note a success of true does not mean the job will restart immediately

#### Path Parameters

| Name | Type   | Description |
| ---- | ------ | ----------- |
|      | string |             |

{% tabs %}
{% tab title="200 " %}

```
{
  "restarted":true
}
```

{% endtab %}
{% endtabs %}

## Example Request

```javascript
{
  "async":"a7ec88af7d710bf51b188004bb532d77"
}
```


# Repost

## Repost

<mark style="color:green;">`POST`</mark> `[PlatformAddress]/api/1.0/batch?action=repost`

#### Path Parameters

| Name  | Type   | Description |
| ----- | ------ | ----------- |
| async | string |             |

{% tabs %}
{% tab title="200 " %}

```
{
  "reposted":true
}
```

{% endtab %}
{% endtabs %}

The repost action takes the asyncId as a parameter and returns the success of the call.

{% hint style="info" %}
Note a success of true does not mean the callback will be hit immediately.
{% endhint %}

## Example Request

`Example: Restart a batch job`

```javascript
{
  "async":"a7ec88af7d710bf51b188004bb532d77"
}
```


# Use Cases

This section gives some common use cases with links to relevant sections in the API.


# CRM Systems

## CRM Integrations

CRM Integrations typically have different modules completed in them for transfer.

* [Contacts](#contacts)
* [Contact Emails](#contact-emails)
* \`\`[Events Software Users](#event-software-users)
  * [Event Registrations](#event-registrations)
  * [Events](#events)
  * [Event Attendees](#event-attendees)
* [Venues Software Users](#venue-software-users)
  * [Companies](#companies)
  * [Quotes & Bookings](#quotes-and-bookings)

## Contacts

Contacts are preferred to be transferred two ways between iVvy and the CRM system so that both systems are always kept up to date.

It is important to remember that iVvy uses three fields to uniquely identify a contact: first name, last name and email. Other systems may not use the same identifiers, so it is recommended that a constant identifier is used (such as a contact ID) to make a permanent pairing of the contacts. iVvy does have a field to store a externalId that our integrations typically use to store the contact ID from the other system.

Typical endpoints used when doing a 2 way contact sync.

* [Get Contact List](/contact/get-contact-list): Using this call with a filter of modifiedDate can give you the list of contacts that were modified in iVvy since the last sync. This minimises the amount of time that is spent comparing the contacts between the two systems. You may or may not also use the get Contact action which returns a single contact.
* [Add or Update Contact](/contact/add-or-update-contact) for when the contacts are being synced back into iVvy.
* [Get subscription group](/contact/get-subscription-group-list) list and [add Contacts to subscription group](/contact/add-contacts-to-subscription-group) if the integration will be supporting syncing of subscription groups.

Remember to provide a method to map custom fields between the two systems if they are also being synced in the integration.

## Contact Emails

As an email is usually stored against a singular action in iVvy, they cannot be received into iVvy from a third party. So contact emails are a one way sync out of iVvy and into the CRM so that the CRM has a comprehensive history of all correspondence sent to the contact.

Typical endpoints used when doing an email sync from iVvy to a CRM:

* [Get Email Log List](/account/get-email-log-list) returns a collection of the emails that have been sent. The content in the body in returned HTML format so it is wise to consider this when syncing the emails into a third party system.

## Event Software Users

If completing a integration for Events users, these are some optional modules that have been popular demand.

### Event Registrations

Event registrations are usually synced into the CRM as opportunities. This is normally optional so that the user can use the CRM portion and not be forced into this feature if they do not wish to use it.

This is associated with the revenue of event registrations being displayed in the CRM system so that more accurate forecasting is completed. It also attaches to the contacts/companies history so that the CRM user can see an accurate historic relationship with the contact/company. This is a one way sync out of iVvy and into the CRM system.

Typical Endpoints used when doing an Event Registration syncs into Opportunities in a CRM.

* [Get Registration List](/events/get-registration-list) can be used to fetch the latest created and modified event registrations from the iVvy system.

Important point to remember is that returned event registrations include both delegate and exhibitor registrations. The data may be filtered depending on which is being targeted. Typical iVvy integrations include both. For a list of registration status they can be found under [Registration Current Status Details](/events/get-registration-list#registration-current-status-details).

Usually only paid “completed” status registrations would be synced, because until payment is received they are not guaranteed as income.

### Events

Events are synced one way out of iVvy and into CRM campaigns. This is normally optional so that the user can use the CRM portion and not be forced into this feature if they do not wish to use it.

This gives the CRM user access to a comprehensive history of what events took place for their clients, and which of the contacts (refer campaign members) actually attended their events. This gives a more comprehensive report of the history and relationship with the customer in the CRM.

Typical Endpoints used when syncing events into a CRM.

* [Get Event List](/events/get-event-list) returns a list of events in the iVvy account. These can then be synced into the corresponding CRM system.

### Event Attendees

Attendees in an iVvy event are synced against the campaign in the CRM as an attendee member. This is included in the optional “Events (campaigns)” module. Part of this sync includes keeping the invitation and attendance status periodically up to date.

Typical Endpoints used when syncing event members into a CRM.

* [Get Invited Contact List](/events/get-invited-contact-list) gives a list of contacts invited to the event. This action will return a response on if they clicked yes, no or haven’t responded yet, however it also updates a registration ID field when the contact progresses onto a registration.
* [Get Attendee List](/events/get-attendee-list) will give a list of contacts that have registered for the event.

Event Registration Progress: Initially a contact would start as an invitation with the following invitation status:

* U = Undecided
* Y = Yes
* N = No

If the attendee has clicked yes than they will be now found in the attendee list as they have completed their registration. Once on the attendee list (meaning they will attend) the “hasAttended” and “sessionHasAttended” flags will verify if the user registered but did or did not attend.

One point to remember is that if the event is not invite only, attendees can still register that haven’t been invited so there may be records in the attendee list that are not in the invited contact list that need to be considered.

## Venue Software Users

If completing a integration for Venues users, these are some optional modules that have been popular demand.

### Companies

The venues software has a component to store companies against contacts (whereas events does not) so a two way company sync (or as some CRMs refer to them as accounts) to keep the two systems up to date. The same as contacts, a company has an externalID field in iVvy that can be used as the constant to map the company together so if there is a name change, then the two companies are still connected and can be kept up to date.

Typical Endpoints used when doing a Company sync

* [Get Company List](/contact/get-company-list) and [Get Company](/contact/get-company) if completing company syncs.
* [Add or Update Company](/contact/add-or-update-company), if sending data back from the third party CRM.

### Quotes and Bookings

Venues may wish for their quotes and bookings to appear in their CRM against the contact / company as an Opportunity. This is usually “optional” so that if the venue wishes to use the CRM, they aren’t forced to use the bookings / quotes module if they do not wish to.

iVvy does not allow for quotes/bookings to be pushed back into the system, and the data in an opportunity does not usually meet the minimum requirements of a quote or booking in the iVvy system so it’s completed as a one way sync out of iVvy and into the CRM System.

Typical Endpoints used when doing a Quotes / Bookings Sync

* [getBookingListForAccount](/venues/getoraddbookingdata/get-booking-list-for-account) (this returns bookings for all venues) [getBookingList](/venues/getoraddbookingdata/get-booking-list) (returns all bookings for a single venue) or [getBooking](/venues/getoraddbookingdata/get-booking) (returns a single booking) can be used to source a list of quotes and bookings out of a venue. To differentiate between a quote and a booking the current status will identify if its Prospective (quote) or Tentative / Confirmed (Booking).

To get the latest bookings that have been created or modified, the result can be filtered by a modifiedDateAfter parameter.


# Financial Accounting Systems

Financial integrations compose of copying the financial history out of iVvy and into a users financial system for reconciliation and reporting.

As there is a vast difference between the way the venues and events invoicing systems work, historically they have been completed separately. Typically iVvy only sync paid invoices on Event Integrations, as events invoices can constantly change up until the point they are paid. However venues invoices do not commonly change, so the process of syncing them and paying them later is followed in the Venues integration.

When creating a financial integration there are a lot of different steps and scenarios to consider.

1. **Contact or Company:** Each invoice will need to have a contact and/or company assigned
2. **Currency:** What currency is the invoice in, and how does it need to be added into the financial system.
3. **Tax:** Tax tax rate is the invoice and its line items using, and how is this translated into the financial system.
4. **Item Ledger Accounts:** Line items in a financial system will typically have a revenue account assigned. Logic around achieving this will need to be decided.
5. **Bank accounts:** When transferring payments into a financial system, the bank account that the funds are sitting in needs to be allocated.
6. **Historical Data:** If you want to do historical data or just data from when the installation occurs.
7. **Transferring payments both ways:** This is a common scenario if a user \* Has a payment gateway in iVvy \* Is adding payments through the financial system to the invoices, such as a bank feed directly into their finance program.
8. **Existing Contacts:** Financial systems may already have a debtor list. A good algorithm to match up contacts in iVvy and the Financial System when syncing invoices and creating a constant between the two such as a contact ID is highly recommended to avoid duplicates.

No two users are the same so iVvy integrations normally offer these as options for the user to set during installation rather than hard wiring them. This allows more flexibility for the end user.

## Common API Actions that would be used in a financial Integration

1. **Fetch the Invoices**

   Invoices can be fetched from iVvy via the [getInvoice](/invoice/get-invoice) and [getInvoiceList](/invoice/get-invoice-list) API actions.

   From these actions currency, tax, items and payment information can be accessed. If completing a separate events or venue integration [filtering by refType](/invoice/get-invoice-list#reference-type) is recommended to get the correct invoices that need to be sourced.\
   One important thing to note for invoices is they may not always have a company ID or contact ID. Invoices in iVvy can be assigned to an “Other”. So this makes working with a contact database tricky in this situation. Typically if there is no contact or company for the invoice the default contact/company is sourced from the Booking or the Event that the invoice is associated with to create the corresponding contact in the Financial System.
2. **Fetching a contact or company for each invoice** A contact or company can be fetched from the iVvy system using the [Get Contact](/contact/get-contact) / [Get Contact List](/contact/get-contact-list) or [Get Company](/contact/get-company) / [Get Company List](/contact/get-company-list) actions. The list actions return different data to the individual actions so make sure you are calling the correct action that returns the information you are looking for. Both may be used in some cases.
3. **Mapping an Invoice Status** It is recommended to look at the invoice status in iVvy and the financial system and map them accordingly deciding on what behavior happens as the status changes in iVvy. The list of [iVvy invoice status](/invoice/get-invoice-list#current-status) can be found here.
4. **Assigning line items to an account in the Financial System** Each line item in iVvy has a refType. These are iVvy constants that could be used to map to a revenue account in the financial system. These can be accessed by the [getOptions](/invoice/get-options) action.
5. **Adding a payment back to iVvy on a two way sync** If both systems are taking payments it makes sense to transfer payments back to iVvy that were taking in the financial system. This can be done by the [Add Payment](/invoice/add-payment) endpoint. The invoice has to be existing in iVvy already (a new one cannot be created), and invoices cannot be overpaid via the API.

## Venues Invoices

Please note this is a general overview which changes for different financial systems depending on how the system works with credit notes and refunds.

![](/files/AGAtE8vDbwewBwHLvXqK)

## Events Invoices

Please note this is a general overview which changes for different financial systems depending on how the system works with credit notes and refunds. The iVvy events API does not pass credit note information so if a user needs to create a refund/credit this is done manually in the financial system.

![](/files/aLzXa2flVnH8zDgIwGd1)


# Point Of Sale

The most common approach to working with a POS integration with iVvy is for confirmed bookings to be pulled into the POS system using the [`Get Booking List`](/venues/getoraddbookingdata/get-booking-list) action so that they are visible on the POS on the day of the event.. The getBooking action will include the total amount of the booking, and outstanding amounts for the event. This allows additional flexibility at the POS level to take any remaining balances for the event and pass back the details to the iVvy booking.

Once the event has taken place, (usually at the time of closing the event) food and beverage items entered through the POS system will be pushed back into iVvy as “Additional Items” using the [`Add Items To Booking`](/venues/getoraddbookingdata/add-items-to-booking) action. When adding additional items back into iVvy from the POS system, a Cost centre needs to be assigned. To determine a list of cost centres in the iVvy venue account, the [`Get Cost Centre List`](/account/get-cost-center-list) action can be used to access and map the cost centres with the POS system.

Then any payments taken are sent into iVvy using the [`Add Payment to Booking`](/venues/getoraddbookingdata/add-payment-to-booking) action. This action will generate a transaction invoice for the amount of the payment and store the payment information against it. This will reduce the outstanding amount of the iVvy booking, giving the user visibility on total amounts outstanding, if any.

The user will then produce the final invoice in iVvy which will contain the summary of billable items from both systems as they were passed into the booking at the time of closing the event in the POS system. Any remaining amounts (if applicable) will be paid against the final invoice.

![](/files/JmBFg5hMfxAt9JuqPqPH)


# Property Management Systems

PMS Integrations are designed to allow the user to keep accommodation up to date between iVvy and their PMS System. They provide live availability and rates from the PMS to iVvy so that accommodation can be booked real time with the correct pricing.

## Group Accommodation Blocks

Group accommodation blocks will be synced from iVvy to the PMS system. The iVvy system will trigger an event when accommodation bookings are created, and release schedules are due.

Changes made by the user in iVvy will trigger an update event which will result in an update in the PMS.

![](/files/9DPErM6Ra6HBwUA3jS8a)

## Room Reservations

Rooming lists take accommodation blocks one step further by allocating single reservations within the accommodation block to indicate the occupant of the room. These reservations will be synced to the PMS so the user has occupant information.

Any changes to the reservations will trigger an event that will update the rooming list in the PMS.

![](/files/B8n48AaEVX342ni7bRf0)

## ARI (Availability, Rates and Inventory)

Availability, rates and inventory will be sourced from the PMS to appear in iVvy as real time data from the PMS. This includes in iVvy displaying up to

* rate plans,
* dynamic inventory and
* room data.

The accommodation Namespace on the iVvy API allows users to;

* [Add or Update Room Counts](/venues/accommodation/add-or-update-room-counts),
* [Add or Update Room Dynamic Rates](/venues/accommodation/add-or-update-room-dynamic-rates),
* [Remove Room Dynamics Rates](/venues/accommodation/remove-room-dynamic-rates), and
* [Add or Update Rate Plan Booking Rules](/getting-started/use-cases/property-management-systems)


# Contacts & Companies

Contacts and Companies are objects used by both the iVvy Events and iVvy Venues Software.

The [Contact ](/contact/get-contact-list)object includes some standard data including email address, first name, last name, mobile phone number and created date. in addition to this, additional Custom Fields can be defined within an account.

Contacts can belong to [Companies](/contact/get-company-list), and Companies have a range of standard data recorded against them.


# Get Contact List

## Get Contact List

<mark style="color:green;">`POST`</mark> `[PlatformAddress]/api/1.0/contact?action=getContactList`

Get Contact List will respond with a list of contacts based on the filter parameters

#### Path Parameters

| Name    | Type    | Description                                                                                                         |
| ------- | ------- | ------------------------------------------------------------------------------------------------------------------- |
| perPage | integer | The number of events to get in a single api call                                                                    |
| start   | integer | The starting result of the page. Note this is zero based (i.e. sending start = 0 will start from the first result.) |

{% tabs %}
{% tab title="200 " %}

```
```

{% endtab %}
{% endtabs %}

## Additional [Filter](/getting-started/interpreting-the-response/filtering) Properties

| Property         | Description                    | Type                                                             |
| ---------------- | ------------------------------ | ---------------------------------------------------------------- |
| fromModifiedDate | Filter by Modified Date        | [iVvy Timestamp Format](/development-reference/timestamp-format) |
| toModifiedDate   | Filter by Modified Date        | [iVvy Timestamp Format](/development-reference/timestamp-format) |
| externalId       | Filter by external unique id   | Unique external Id in string                                     |
| venueId          | Filter by specific Venue       | integer                                                          |
| venueGroupId     | Filter by specific Venue Group | integer                                                          |
| companyId        | Filter by specific Company Id  | integer                                                          |

## Returns

| Property           | Description                                                                                                      |
| ------------------ | ---------------------------------------------------------------------------------------------------------------- |
| id                 | The unique identifier for the contact                                                                            |
| firstName          | The contact’s first name                                                                                         |
| lastName           | The contact’s last name                                                                                          |
| email              | The contact’s email address                                                                                      |
| phone              | The contact’s phone number                                                                                       |
| privacyConsentData | The object of [Privacy Consent](/contact/get-contact#privacy-consent-data) field objects of the contact.         |
| customFields       | The custom field information for the contact. This is an array of fields, each an object with the [keys](#keys). |
| groups             | The subscription group information for the contact.                                                              |
| companies          | This will an array company ids to which the contact belongs.                                                     |
| companiesData      | This will an array company containing id and businessName for each company to which the contact belongs.         |
| externalId         | This will be external id of the contact                                                                          |
| modifiedDate       | The modified date of the contact                                                                                 |
| isAnonymised       | Whether or not contact data is annonymised                                                                       |

## keys

| fieldId     |
| ----------- |
| displayName |
| value       |

The result from this call will be a [collection](/getting-started/interpreting-the-response/collections) of all the events the user has access to. This call also accepts the [pagination](/getting-started/interpreting-the-response/pagination) and [filter](/getting-started/interpreting-the-response/filtering) properties.


# Get Contact

## Get Contact

<mark style="color:green;">`POST`</mark> `[PlatformAddress]/api/1.0/contact?action=getContact`

Get the contact details

#### Path Parameters

| Name              | Type    | Description                                                                                       |
| ----------------- | ------- | ------------------------------------------------------------------------------------------------- |
| id                | integer | The contact's identifier                                                                          |
| useEventSortOrder | boolean | If true, the eventInvitations and eventRegistrations will be returned ordered by Event Start Date |

{% tabs %}
{% tab title="200 " %}

```javascript
{
    "id": 7427530,
    "firstName": "Test",
    "lastName": "User",
    "email": "user@test.com",
    "phone": "0455550000",
    "status": 1,
    "smsStatus": 1,
    "customFields": [],
    "groups": [
        {
            "contactId": 7427530,
            "groupId": 57138,
            "joinDate": "2018-09-07 02:11:47"
        }
    ],
    "companies": [4, 5, 6],
    "companiesData":[
        {"id":4,"businessName":"Company Name 1"},
        {"id":5,"businessName":"Company Name 3 (Department)"},
        {"id":6,"businessName":"Company Name 2"},
    ],
    "externalId": null,
    "modifiedDate": "2018-09-07 02:11:47 UTC",
    "isAnonymised": false,
    "eventInvitations": [],
    "eventRegistrations": []
}
```

{% endtab %}
{% endtabs %}

### Example Request

This example request will obtain the details of the contact with the id "6"

```javascript
{
  "id":6
}
```

## Returns

|                    |                                                                                                                                                               |          |
| ------------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------- | -------- |
| **Property**       | **Description**                                                                                                                                               | **Type** |
| id                 | The unique identifier for the contact                                                                                                                         | integer  |
| firstName          | The contact’s first name                                                                                                                                      | string   |
| lastName           | The contact’s last name                                                                                                                                       | string   |
| email              | The contact’s email address                                                                                                                                   | string   |
| phone              | The contact’s phone number                                                                                                                                    | integer  |
| status             | The contact's [email status](#email-status)                                                                                                                   | enum     |
| smsStatus          | The contact’s [sms status](#sms-status)                                                                                                                       | enum     |
| customFields       | The custom field information for the contact. This is an array of fields, each an object with the [keys](#custom-fields-keys).                                | array    |
| groups             | The subscription group information for the contact.                                                                                                           | array    |
| companies          | This will an array company ids to which the contact belongs.                                                                                                  | array    |
| companiesData      | This will an array company containing id and businessName for each company to which the contact belongs.                                                      | array    |
| externalId         | This will be an external id of the contact                                                                                                                    | integer  |
| modifiedDate       | The modified date of the contact                                                                                                                              | date     |
| isAnonymised       | Whether or not contact data is annonymised                                                                                                                    | boolean  |
| eventInvitations   | An array of events the contact has been invited to. Each element of the array is an object with [the event invitations fields](#event-invitations)            | array    |
| eventRegistrations | An array of events the contact has registered for. Each element of the array is an object with [the event registration fields](#event-registrations-details). | array    |
| externalUrls       | This is an array of [ExternalUrl](#external-url-field) field objects of the contact.                                                                          | array    |
| privacyConsentData | The object of [Privacy Consent](#privacy-consent-data) field objects of the contact.                                                                          | object   |

### Status Options - Email Registration Status

The status is the record of whether the contact has opted in to email communication.

|       |                 |
| ----- | --------------- |
| **#** | **Description** |
| 1     | Subscribed      |
| 2     | Unsubscribed    |
| 3     | Bounced         |
| 4     | Registering     |
| 5     | No Marketing    |

### Sms status

The sms status is the record of whether the contact has opted in to sms communication.

|       |                 |
| ----- | --------------- |
| **#** | **Description** |
| 1     | Subscribed      |
| 2     | Unsubscribed    |
| 3     | Failed          |
| 4     | No Marketing    |

### Custom Fields Keys

|             |
| ----------- |
| **Keys**    |
| fieldId     |
| displayName |
| value       |

### Event Invitations

|                    |                                                                                       |
| ------------------ | ------------------------------------------------------------------------------------- |
| **Property**       | **Description**                                                                       |
| eventId            | The event identifier of the invitation                                                |
| eventCode          | The code of the event of the invitation                                               |
| eventStartDateTime | The timestamp the event is starting                                                   |
| inviteLinkYes      | Invitation link for the Yes response for this contact to the event                    |
| inviteLinkNo       | Invitation link for No response for this contact to the event                         |
| response           | The contacts response to the invitation. [List of response values](#response-values). |

#### Event Invitations Response values

|       |                 |
| ----- | --------------- |
| **#** | **Description** |
| U     | Undecided       |
| Y     | Yes             |
| N     | No              |

### Event Registrations Details

|                    |                                                                                                                                            |
| ------------------ | ------------------------------------------------------------------------------------------------------------------------------------------ |
| **Property**       | **Description**                                                                                                                            |
| eventId            | The event identifier of the registration                                                                                                   |
| eventCode          | The code of the event of the registration                                                                                                  |
| eventStartDateTime | The timestamp the event is starting                                                                                                        |
| registrationId     | The unique identifier of the registration                                                                                                  |
| currentStatus      | [The status of the registration](#registration-status)                                                                                     |
| confirmedDate      | Timestamp of the date the registration was confirmed                                                                                       |
| isPaymentWaiting   | If the registration is payment waiting or not                                                                                              |
| printTicketUrl     | The URL the registrations tickets                                                                                                          |
| printTicketUrlPdf  | Link to the PDF for the registrations tickets                                                                                              |
| attendeeCount      | Total number of attendees for this registration                                                                                            |
| invoiceUrl         | The URL for the registration primary invoice                                                                                               |
| invoiceUrlPdf      | Link to the PDF for the registration primary invoice                                                                                       |
| guestDetails       | An array of objects with [the guest details.](#guest-details)                                                                              |
| invoices           | The list of invoices associated with the registration. Each element of the array is an object with [the invoice fields.](#invoice-details) |

#### Event Registration Status (currentStatus)

|       |                  |
| ----- | ---------------- |
| **#** | **Description**  |
| 2     | Completed        |
| 3     | Cancelled        |
| 4     | Payment Required |

#### Guest Details

|                  |                                         |
| ---------------- | --------------------------------------- |
| **Property**     | **Description**                         |
| contactId        | The identifier for the contact if known |
| fullName         | Name of guest                           |
| email            | Email address of guest                  |
| attended         | If the contact has attended the event   |
| attendedDateTime | When the contact attended the event     |

### Invoice Details

|               |                                                                                                                                    |
| ------------- | ---------------------------------------------------------------------------------------------------------------------------------- |
| **Property**  | **Description**                                                                                                                    |
| id            | The unique identifier for the invoice                                                                                              |
| reference     | The reference number of the invoice                                                                                                |
| title         | The title of the invoice                                                                                                           |
| currentStatus | The current status of the invoice. The value of this field will be [one of the following current status](#invoice-current-status). |
| description   | The description of the invoice                                                                                                     |
| currency      | The currency of the values of this invoice                                                                                         |
| totalCost     | The total amount of the invoice                                                                                                    |
| totalPaid     | How much has been paid off the invoice                                                                                             |
| invoiceUrl    | The URL for the invoice                                                                                                            |
| invoiceUrlPdf | The URL for the invoice pdf                                                                                                        |

#### Invoice current status

|       |                  |
| ----- | ---------------- |
| **#** | **Description**  |
| 0     | Not Paid         |
| 1     | Unconfirmed Paid |
| 2     | Written Off      |
| 3     | Failed           |
| 4     | Cancelled        |
| 5     | Refunded         |

The result from this call will be a [collection](/getting-started/interpreting-the-response/collections) of all the events the user has access to. This call also accepts the [pagination](/getting-started/interpreting-the-response/pagination) and [filter](/getting-started/interpreting-the-response/filtering) properties.

## External URL Field

An External URL field is an object with the following details.

| Property | Type   | Description                                           |
| -------- | ------ | ----------------------------------------------------- |
| ref      | string | The unique reference key of the external URL          |
| url      | string | The url link (https) scheme eg. <https://example.com> |
| label    | string | The label of the URL to display.                      |

## Privacy Consent Data

| Property | Description                                          |
| -------- | ---------------------------------------------------- |
| source   | The [source](#privacy-consent-source) of the consent |
| dateTime | The date time when the consent given                 |

## Privacy Consent Source

| Source | Description            |
| ------ | ---------------------- |
| 1      | User Initiated Entry   |
| 2      | Marketplace            |
| 3      | Website Booking Engine |
| 4      | Event Website          |
| 5      | API                    |

## Throws

|                      |                        |
| -------------------- | ---------------------- |
| **Code**             | **Description**        |
| Specific Code: 24096 | Unable to find contact |

The contact identifier must be provided to fetch a specific contact from the system.


# Get Contact Note List

## Get Contact Note List

<mark style="color:green;">`POST`</mark> `[PlatformAddress]/api/1.0/contact?action=getContactNoteList`

Fetches a list of notes for a specific contact.

#### Path Parameters

| Name      | Type    | Description                                                                                                       |
| --------- | ------- | ----------------------------------------------------------------------------------------------------------------- |
| contactId | integer | The unique identifier of the contact to which the contact notes belong                                            |
| perPage   | integer | The number of contact notes to fetch                                                                              |
| start     | integer | The starting result of the page. Note this is zero based (i.e. sending start=0 will start from the first result.) |

{% tabs %}
{% tab title="200 " %}

```
{
    "meta": {
        "totalResults": 10,
        "start": 0,
        "perPage": 50,
        "count": 3
    },
    "results": [
        {
            "id": 2,
            "contactId": 4,
            "noteText": "<p>Contact Note 1</p>\n",
            "createdByUserId": 1,
            "createdDate": "2022-06-12 06:06:03 UTC",
            "modifiedDate": "2022-07-13 01:32:10"
        },
        {
            "id": 4,
            "contactId": 4,
            "noteText": "<p>Contact Note 2</p>\n",
            "createdByUserId": 1,
            "createdDate": "2022-07-13 01:27:27 UTC",
            "modifiedDate": "2022-07-13 01:27:27"
        },
        {
            "id": 5,
            "contactId": 4,
            "noteText": "<p>Contact Note 3</p>\n",
            "createdByUserId": 1,
            "createdDate": "2022-07-13 01:29:41 UTC",
            "modifiedDate": "2022-07-13 01:29:41"
        },
    ]
}

```

{% endtab %}
{% endtabs %}

The result from this call will be a [collection](/getting-started/interpreting-the-response/collections) of contact note to which the user has access. This call also accepts the [pagination](/getting-started/interpreting-the-response/pagination) and [filter](/getting-started/interpreting-the-response/filtering) properties.

## Example Request

`Fetches a list of Notes for a specific Contact`

```javascript
{
    "contactId" : 4,
    "perPage" : 50
}
```

## Contact Note

| Property        | Type      | Description                                             |
| --------------- | --------- | ------------------------------------------------------- |
| id              | integer   | The unique id of the contact note                       |
| contactId       | integer   | The id of the contact to which the contact note belongs |
| noteText        | string    | The contact note                                        |
| createdByUserId | integer   | The details of person who created the contact note      |
| createdDate     | timestamp | The date & time the contact note was created            |
| modifiedDate    | timestamp | The date & time the contact note was last modified      |


# Add or Update Contact

## Add or Update Contact

<mark style="color:green;">`POST`</mark> `[PlatformAddress]/api/1.0/contact?action=addOrUpdateContact`

Add or update contact details

#### Request Body

| Name           | Type    | Description                                                                                                                                                               |
| -------------- | ------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| externalId     | string  | Reference to the ID of the contact in an external system.                                                                                                                 |
| id             | integer | The contact's identifier. (Leave empty to add new contact)                                                                                                                |
| firstName      | string  | The contact's first name (required when id is missing)                                                                                                                    |
| LastName       | string  | The contact's last name (required when id is missing)                                                                                                                     |
| email          | string  | The contact's email address. Must be a valid email. (required when id is missing)                                                                                         |
| phone          | string  | The contacts phone number.                                                                                                                                                |
| groups         | string  | The array of subscription groups to set for the contact. Note: This list will override any groups currently set for the contact.                                          |
| customFields   | string  | The array of custom fields to set on the contact. Each field will be validated depending on the type of field that is set.                                                |
| companies      | string  | The array of companies to set on the contact. Each value will be validated depending on the type of field as well as it will verify that the given company exists or not. |
| status         | enum    | The contact's email subscription status.                                                                                                                                  |
| smsStatus      | enum    | The contact's sms subscription status.                                                                                                                                    |
| updateIfExists | boolean | Whether or not to update the contact by firstName, lastName and email when id parameter is missing.                                                                       |
| externalUrls   | array   | This is an array of External URL field objects of the contact (a maximum of 3 objects allowed). When set to null, it will remove all externalUrls from the contact.       |

{% tabs %}
{% tab title="200 " %}

```
{
  "id":33884
}
```

{% endtab %}
{% endtabs %}

## Example Request: Adding a contact

```javascript
{
  "firstName": "Bobby",
  "lastName": "Smith",
  "email": "bobbysmith@hotmail.com",
  "groups": [
    {
      "groupId": 10
    }
  ],
  "customFields": [
    {
      "fieldId": 33443,
      "value": "No"
    }
  ],
  "companies": [
    4,
    5
  ],
  "status": 2,
  "smsStatus": 2,
  "externalId" : "12345",
  "externalUrls" : [
        {
            "ref": "example1",
            "label": "Example One",
            "url": "https://example1.com"
        },
        {
            "ref": "example2",
            "label": "Example Two",
            "url": "https://example2.com"
        },
        {
            "ref": "example3",
            "label": "Example Three",
            "url": "https://example3.com"
        }
    ],
    "privacyConsent": true
}
```

## Example Request: Updating a contact

`Note : the groups will be set to only group 10, destroying the existing value`

```javascript
{
  "id":33884,
  "firstName":"Bobby",
  "groups":[{"groupId":10}],
  "customFields":[{"fieldId":33443,"value":"No"}],
  "companies":[4,5],
  "status": 2,
  "smsStatus": 2,
}
```

This call takes values for a contact, and either

1. Updates the values for that contact (after you have provided an id in the parameters), or
2. Adds the contact to the system (if the id parameter is missing)

The result of this call will contain the status of the result (either true or false) and the contact identifier of the updated or newly created contact.

The properties of the contact currently supported are:

* firstName
* lastName
* email
* phone
* groups
  * This is an array of group objects with the ‘groupId’ key.
* customFields
  * This is an array of custom field objects with ‘fieldId’ and ‘value’ keys
* Companies
  * This is an array of companies Ids
* status
  * The current status of the email susbcription in contact. The value of this field will be [one of the following current status](#email-status)
* smsStatus
  * The current status of the sms susbcription in contact. The value of this field will be [one of the following current status](#sms-status)
* externalUrls
  * This is an array of External URL field objects of the contact (a maximum of 3 objects allowed). When set to null, it will remove all externalUrls from the contact. [ExternalUrl field](#external-url-field)
* privacyConsent
  * Whether or not giving privacy consent for this contact.

## Returns

| Property | Description                                      |
| -------- | ------------------------------------------------ |
| success  | If the contact was successfully added or updated |
| id       | The unique identifier for the contact            |
| message  | Message of the failure (if success was false)    |

### Email Status

The status is the record of whether the contact has opted in to email communication.

|       |                 |
| ----- | --------------- |
| **#** | **Description** |
| 1     | Subscribed      |
| 2     | Unsubscribed    |
| 3     | Bounced         |
| 5     | No Marketing    |

### Sms status

The sms status is the record of whether the contact has opted in to sms communication.

|       |                 |
| ----- | --------------- |
| **#** | **Description** |
| 1     | Subscribed      |
| 2     | Unsubscribed    |
| 3     | Failed          |
| 4     | No Marketing    |

## External URL Field

An External URL field is an object with the following details.

| Property | Type   | Required | Description                                                                                                                                                |
| -------- | ------ | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------- |
| ref      | string | required | The unique reference key of the external URL                                                                                                               |
| url      | string | optional | The url link (https) scheme eg. <https://example.com> When the value is null, the external url record will be removed based on the provided reference key. |
| label    | string | optional | The label of the URL to display.                                                                                                                           |


# Get Contact Custom Field Definition

## Get Custom Field Definition

<mark style="color:green;">`POST`</mark> `[PlatformAddress]/api/1.0/contact?action=getCustomFieldDefinition`

Get the definition of custom field

{% tabs %}
{% tab title="200 " %}

```
```

{% endtab %}
{% endtabs %}

## Returns

An array of objects with the following properties

| Property     | Description                                                    |
| ------------ | -------------------------------------------------------------- |
| fieldId      | The unique identifier for this custom field                    |
| fieldType    | [The type of this field](#types-of-field)                      |
| displayName  | The name of this field                                         |
| isRequired   | If this field is required or not                               |
| isActive     | If this field is active or not                                 |
| sortOrder    | Order to display this field                                    |
| selectValues | Values that can be selected with select fields                 |
| fileTypes    | Types of files that can be uploaded with the file custom field |

## Types of field

* 0 = Small Text
* 1 = Large Text
* 2 = Single Select
  * Valid options are provided in the ‘selectValues’ key
* 3 = Multiple Select
  * Valid options are provided in the ‘selectValues’ key
* 4 = Address
* 5 = Date
* 6 = File
  * Valid file types are provided in the ‘fileTypes’ key
* 7 = Static Text
  * Values cannot be set for this type
* 8 = Whole Number

This call will return an array of custom fields available on the account. The result will have the fieldId which is the unique field identifier for the specific field, as well as the display name and any options required for each field.

As part of the field definition there is a ‘fieldType’ property which can be resolved to the following types

* 0 = Small Text
* 1 = Large Text
* 2 = Single Select
  * Valid options are provided in the ‘selectValues’ key
* 3 = Multiple Select
  * Valid options are provided in the ‘selectValues’ key
* 4 = Address
* 5 = Date
* 6 = File
  * Valid file types are provided in the ‘fileTypes’ key
* 7 = Static Text
  * Values cannot be set for this type
* 8 = Whole Number


# Get Company Custom Field Definition

## Get Company Custom Field Definition

<mark style="color:green;">`POST`</mark> `[PlatformAddress]/api/1.0/contact?action=getCompanyCustomFieldDefinition`

Get the definition of custom field

{% tabs %}
{% tab title="200 " %}

```
[
    {
        "fieldId": 47,
        "fieldType": 3,
        "displayName": "Test Multiple",
        "isRequired": false,
        "isActive": true,
        "sortOrder": 1,
        "selectValues": {
            "Test 1": "Test 1",
            "Test 2": "Test 2"
        },
        "fileTypes": null
    },
    {
        "fieldId": 1,
        "fieldType": 0,
        "displayName": "TIN Number",
        "isRequired": false,
        "isActive": true,
        "sortOrder": 2,
        "selectValues": null,
        "fileTypes": null
    },
    {
        "fieldId": 2,
        "fieldType": 4,
        "displayName": "Accountant Address",
        "isRequired": false,
        "isActive": false,
        "sortOrder": 3,
        "selectValues": null,
        "fileTypes": null
    },
    {
        "fieldId": 3,
        "fieldType": 5,
        "displayName": "Your Birth Date",
        "isRequired": true,
        "isActive": true,
        "sortOrder": 4,
        "selectValues": null,
        "fileTypes": null
    },
    {
        "fieldId": 45,
        "fieldType": 6,
        "displayName": "Profile Picture",
        "isRequired": false,
        "isActive": true,
        "sortOrder": 5,
        "selectValues": null,
        "fileTypes": [
            "images"
        ]
    }
]
```

{% endtab %}
{% endtabs %}

## Returns

An array of objects with the following properties

| Property     | Description                                                                   |
| ------------ | ----------------------------------------------------------------------------- |
| fieldId      | The unique identifier for this custom field                                   |
| fieldType    | [The type of this field](/contact/get-custom-field-definition#types-of-field) |
| displayName  | The name of this field                                                        |
| isRequired   | If this field is required or not                                              |
| isActive     | If this field is active or not                                                |
| sortOrder    | Order to display this field                                                   |
| selectValues | Values that can be selected with select fields                                |
| fileTypes    | Types of files that can be uploaded with the file custom field                |

## Types of field

* 0 = Small Text
* 1 = Large Text
* 2 = Single Select
  * Valid options are provided in the ‘selectValues’ key
* 3 = Multiple Select
  * Valid options are provided in the ‘selectValues’ key
* 4 = Address
* 5 = Date
* 6 = File
  * Valid file types are provided in the ‘fileTypes’ key
* 7 = Static Text
  * Values cannot be set for this type
* 8 = Whole Number
* 9 = Large Select

This call will return an array of custom fields available on the account. The result will have the fieldId which is the unique field identifier for the specific field, as well as the display name and any options required for each field.

As part of the field definition there is a ‘fieldType’ property which can be resolved to the following types

* 0 = Small Text
* 1 = Large Text
* 2 = Single Select
  * Valid options are provided in the ‘selectValues’ key
* 3 = Multiple Select
  * Valid options are provided in the ‘selectValues’ key
* 4 = Address
* 5 = Date
* 6 = File
  * Valid file types are provided in the ‘fileTypes’ key
* 7 = Static Text
  * Values cannot be set for this type
* 8 = Whole Number
* 9 = Large Select


# Get Subscription Group List

## Get Subscription Group List

<mark style="color:green;">`POST`</mark> `[PlatformAddress]/api/1.0/contact?action=getSubscriptionGroupList`

{% tabs %}
{% tab title="200 " %}

```
```

{% endtab %}
{% endtabs %}

Subscription Groups are a feature that enables customers to segment their contacts into groups. These groups can then used for a range of purposes, including email and sms marketing, restricting access to event ticket types and content pages plus more.

## Returns

An array with the following properties

| Property    | Description                         |
| ----------- | ----------------------------------- |
| id          | The subscription group identifier   |
| groupName   | The name for the group              |
| memberCount | The number of contacts in the group |
| tagColour   | The designated colour for the group |

Returns an array of subscription groups available on the account.


# Add Contacts To Subscription Group

## Add Contacts To Subscription Group

<mark style="color:green;">`POST`</mark> `[PlatformAddress]/api/1.0/contact?action=addContactsToSubscriptionGroup`

Add contact details to subscription group

#### Path Parameters

| Name     | Type    | Description                                                                                |
| -------- | ------- | ------------------------------------------------------------------------------------------ |
| contacts | integer | The contact identifiers to subscribe to the group. This is an array of contact identifiers |
| group    | integer | The subscription group identifier to add the contacts to                                   |

{% tabs %}
{% tab title="200 " %}

```
[
  {
    "contactId": 4,
    "status": true
  },
  {
    "contactId": 6,
    "status": true
  },
  {
    "contactId": 55,
    "status": true
  },
  {
    "contactId": 33,
    "status": false
  }
]
```

{% endtab %}
{% endtabs %}

## Example Request

```javascript
{
  "contacts": [
    4,
    6,
    55,
    33
  ],
  "group": 2481
}
```

## Returns

An array of objects with the following properties

| Property  | Description                                  |
| --------- | -------------------------------------------- |
| contactId | The contact this result is for               |
| status    | If the contact was added to the group or not |


# Remove Contacts From Subscription Group

## Remove Contacts From Subscription Groups

<mark style="color:green;">`POST`</mark> `[PlatformAddress]/api/1.0/contact?action=removeContactsFromSubscriptionGroup`

Remove contact details from a subscription group

#### Path Parameters

| Name     | Type    | Description                                                   |
| -------- | ------- | ------------------------------------------------------------- |
| contacts | integer | The contact identifiers to unsubscribe from the group         |
|          | integer | The subscription group identifier to remove the contacts from |

{% tabs %}
{% tab title="200 " %}

```
```

{% endtab %}
{% endtabs %}

## Returns

An array of objects with the following properties

| Property  | Description                                      |
| --------- | ------------------------------------------------ |
| contactId | The contact this result is for                   |
| status    | If the contact was removed from the group or not |

Removes a number of contacts from a subscription group. This call is very similar to the [addContactsToSubscriptionGroup](/contact/add-contacts-to-subscription-group) call. It takes the same parameters and returns the same result.


# Get Company List

## Get Company List

<mark style="color:green;">`POST`</mark> `[PlatformAddress]/api/1.0/contact?action=getCompanyList`

Get a list of companies

#### Path Parameters

| Name    | Type    | Description                                                                                                        |
| ------- | ------- | ------------------------------------------------------------------------------------------------------------------ |
| perPage | integer | The number of companies to get in a single call                                                                    |
| start   | integer | The starting result of the page. Not this is zero based (i.e. sending start = 0 will start from the first result.) |

{% tabs %}
{% tab title="200 " %}

```
```

{% endtab %}
{% endtabs %}

## Additional [Filter ](/getting-started/interpreting-the-response/filtering)Properties

| Property         | Description                    | Type                                                             |
| ---------------- | ------------------------------ | ---------------------------------------------------------------- |
| fromModifiedDate | Filter by Modified Date        | [iVvy Timestamp Format](/development-reference/timestamp-format) |
| toModifiedDate   | Filter by Modified Date        | [iVvy Timestamp Format](/development-reference/timestamp-format) |
| venueId          | Filter by specific Venue       | integer                                                          |
| venueGroupId     | Filter by specific Venue Group | integer                                                          |

## Returns

| Property                     | Description                                                                                                                    |
| ---------------------------- | ------------------------------------------------------------------------------------------------------------------------------ |
| id                           | The unique identifier for the company                                                                                          |
| externalId                   | Optionally a unique identifier of the company that is managed by an external application                                       |
| businessName                 | The company's business name                                                                                                    |
| tradingName                  | The company's trading name                                                                                                     |
| businessNumber               | The company's registration number                                                                                              |
| phone                        | The company's phone number                                                                                                     |
| fax                          | The company's fax number                                                                                                       |
| website                      | The company's website                                                                                                          |
| email                        | The company's email address                                                                                                    |
| address                      | The company’s address. This is an an object with the address [keys](#keys).                                                    |
| modifiedDate                 | The modified date of the company                                                                                               |
| primaryAccountManager        | The primary account manager of the company. This is an an object with the [keys](#primaryaccountmanager)                       |
| secondaryAccountManager      | The secondary account manager of the company. This is an an object with the [keys](#secondaryaccountmanager)                   |
| industry                     | The industry of the company. This is an an object with the [keys](#industry)                                                   |
| primaryContact               | The primary contact of the company. This is an an object with the [keys](#primarycontact)                                      |
| isAgent                      | Whether the company is an agent or not.                                                                                        |
| parentCompanyId              | The parent company id of the company                                                                                           |
| leftValue                    | The left value of the node in the tree structure.                                                                              |
| rightValue                   | The right value of the node in the tree structure.                                                                             |
| depth                        | The depth of this company in the tree structure.                                                                               |
| rootId                       | The root company id.                                                                                                           |
| commissionSpace              | The commission amount of the company space.                                                                                    |
| commissionSpaceType          | The commission amount type of the company space.                                                                               |
| commissionFoodValue          | The commission amount of the company food.                                                                                     |
| commissionFoodType           | The commission amount type of the company food.                                                                                |
| commissionBeverageValue      | The commission amount of the company beverage.                                                                                 |
| commissionBeverageType       | The commission amount type of the company beverage.                                                                            |
| commissionAudioVisualValue   | The commission amount of the company audio visual.                                                                             |
| commissionAudioVisualType    | The commission amount type of the company audio visual.                                                                        |
| commissionAccommodationValue | The commission amount of the company accommodation.                                                                            |
| commissionAccommodationType  | The commission amount type of the accommodation.                                                                               |
| iataNumber                   | The IATA number of commission payable to the agent.                                                                            |
| customFields                 | The custom field information for the company. This is an array of fields, each an object with the [keys](#custom-fields-keys). |

## Keys

| keys                  |
| --------------------- |
| line1                 |
| line2                 |
| line3                 |
| line4                 |
| city                  |
| stateCode (e.g: QLD)  |
| countryCode (e.g: AU) |
| postalCode            |

## primarycontact

| Property  | Type    | Description                          |
| --------- | ------- | ------------------------------------ |
| id        | integer | The unique identifier of the contact |
| firstName | string  | The first name of the contact        |
| lastName  | string  | The last name of the contact         |
| email     | string  | The email address of the contact     |
| phone     | string  | The phone number of the contact      |

## primaryaccountmanager

| Property  | Type    | Description                                          |
| --------- | ------- | ---------------------------------------------------- |
| id        | integer | The unique identifier of the primary account manager |
| firstName | string  | The first name of the primary account manager        |
| lastName  | string  | The last name of the primary account manager         |
| email     | string  | The email address of the primary account manager     |

## secondaryaccountmanager

| Property  | Type    | Description                                            |
| --------- | ------- | ------------------------------------------------------ |
| id        | integer | The unique identifier of the secondary account manager |
| firstName | string  | The first name of the secondary account manager        |
| lastName  | string  | The last name of the secondary account manager         |
| email     | string  | The email address of the secondary account manager     |

## industry

| Property | Type    | Description                           |
| -------- | ------- | ------------------------------------- |
| id       | integer | The unique identifier of the industry |
| name     | string  | The name of the industry              |

### Custom Fields Keys

\| fieldId | | displayName | | value |

The result from this call will be a [collection](/getting-started/interpreting-the-response/collections) of all the events the user has access to. This call also accepts the [pagination](/getting-started/interpreting-the-response/pagination) and [filter](/getting-started/interpreting-the-response/filtering) properties.


# Get Company

## Get Company

<mark style="color:green;">`POST`</mark> `[PlatformAddress]/api/1.0/contact?action=getCompany`

Get a single company's detail

#### Path Parameters

| Name | Type    | Description              |
| ---- | ------- | ------------------------ |
| id   | integer | The company's identifier |

{% tabs %}
{% tab title="200 " %}

```
{
  "id": "25146",
  "businessName": "Test",
  "tradingName": "Test Trading",
  "businessNumber": "1234586",
  "email": "company@test.com",
  "phone": "0455550000",
  "otherPhone": "123456789",
  "fax": "0455550125",
  "website": "www.test.com",
  "address": {
    "line1": "Street Number",
    "line2": "Street Name",
    "line3": "",
    "line4": "",
    "city": "Gold Coast",
    "stateCode": "QLD",
    "countryCode": "AU",
    "postalCode": "4227"
  },
  "customFields": [
      {
          "fieldId": 5,
          "displayName": "Birth Date",
          "value": "1985-03-17 23:00:00 UTC"
      }
  ],
  "primaryAccountManager": "Test User",
  "secondaryAccountManager": "Test User",
  "industry": "Industry Name",
  "primaryContact": "Test User",
  "commissionRoomHireValue": 123,
  "commissionRoomHireType": "CHF",
  "commissionFoodValue": 222,
  "commissionFoodType": "CHF",
  "commissionBeverageValue": 333,
  "commissionBeverageType": "CHF",
  "commissionAudioVisualValue": 444,
  "commissionAudioVisualType": "CHF",
  "commissionAccommodationValue": 555,
  "commissionAccommodationType": "CHF",
  "iataNumber": "123456789"
}
```

{% endtab %}
{% endtabs %}

## Example Request

`Get a specific company`

```javascript
{
  "id":6
}
```

## Returns

| Property                     | Description                                                                                                                    |
| ---------------------------- | ------------------------------------------------------------------------------------------------------------------------------ |
| id                           | The unique identifier for the company                                                                                          |
| externalId                   | Optionally a unique identifier of the company that is managed by an external application                                       |
| businessName                 | The company's business name                                                                                                    |
| tradingName                  | The company's trading name                                                                                                     |
| businessNumber               | The company's registration number                                                                                              |
| phone                        | The company's phone number                                                                                                     |
| otherPhone                   | The company's other phone number                                                                                               |
| fax                          | The company's fax number                                                                                                       |
| website                      | The company's website                                                                                                          |
| email                        | The company's email address                                                                                                    |
| address                      | The company’s address. This is an an object with the [keys](#keys)                                                             |
| modifiedDate                 | The modified date of the company                                                                                               |
| primaryAccountManager        | The primary account manager of the company. This is an an object with the [keys](#primaryaccountmanager)                       |
| secondaryAccountManager      | The secondary account manager of the company. This is an an object with the [keys](#secondaryaccountmanager)                   |
| industry                     | The industry of the company. This is an an object with the [keys](#industry)                                                   |
| primaryContact               | The primary contact of the company. This is an an object with the [keys](#primarycontact)                                      |
| isAgent                      | Whether the company is an agent or not.                                                                                        |
| parentCompanyId              | The parent company id of the company                                                                                           |
| leftValue                    | The left value of the node in the tree structure.                                                                              |
| rightValue                   | The right value of the node in the tree structure.                                                                             |
| depth                        | The depth of this company in the tree structure.                                                                               |
| rootId                       | The root company id.                                                                                                           |
| commissionSpace              | The commission amount of the company space.                                                                                    |
| commissionSpaceType          | The commission amount type of the company space.                                                                               |
| commissionFoodValue          | The commission amount of the company food.                                                                                     |
| commissionFoodType           | The commission amount type of the company food.                                                                                |
| commissionBeverageValue      | The commission amount of the company beverage.                                                                                 |
| commissionBeverageType       | The commission amount type of the company beverage.                                                                            |
| commissionAudioVisualValue   | The commission amount of the company audio visual.                                                                             |
| commissionAudioVisualType    | The commission amount type of the company audio visual.                                                                        |
| commissionAccommodationValue | The commission amount of the company accommodation.                                                                            |
| commissionAccommodationType  | The commission amount type of the accommodation.                                                                               |
| iataNumber                   | The IATA number of commission payable to the agent.                                                                            |
| customFields                 | The custom field information for the company. This is an array of fields, each an object with the [keys](#custom-fields-keys). |
| externalUrls                 | This is an array of [ExternalUrl](#external-url-field) field objects of the company.                                           |

## Keys

|                       |
| --------------------- |
| **keys**              |
| line1                 |
| line2                 |
| line3                 |
| line4                 |
| city                  |
| stateCode (e.g: QLD)  |
| countryCode (e.g: AU) |
| postalCode            |

## primarycontact

| Property  | Type    | Description                          |
| --------- | ------- | ------------------------------------ |
| id        | integer | The unique identifier of the contact |
| firstName | string  | The first name of the contact        |
| lastName  | string  | The last name of the contact         |
| email     | string  | The email address of the contact     |
| phone     | string  | The phone number of the contact      |

## primaryaccountmanager

| Property  | Type    | Description                                          |
[...]
